/*
  A persistent variable in the server.
*/
function Counter(data) {

    Object.defineProperties(this, {
        /*
          The variable name
        */
        "counter": {
            value: data ? data.counter : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The variable value.
          Many variables are numerical in nature, which allow you to do atomic increment operations in method calls instead of having to fetch, increment, and save.

        */
        "value": {
            value: data ? data.value : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Counter;
