<?php
/**
 * ChangesCommand
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * ChangesCommand Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ChangesCommand implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'change' => 'string',
        'date' => '\DateTime',
        'user' => 'string',
        'client' => 'string',
        'status' => 'string',
        'type' => 'string',
        'path' => 'string',
        'description' => 'string'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'change' => 'change',
        'date' => 'date',
        'user' => 'user',
        'client' => 'client',
        'status' => 'status',
        'type' => 'type',
        'path' => 'path',
        'description' => 'description'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'change' => 'setChange',
        'date' => 'setDate',
        'user' => 'setUser',
        'client' => 'setClient',
        'status' => 'setStatus',
        'type' => 'setType',
        'path' => 'setPath',
        'description' => 'setDescription'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'change' => 'getChange',
        'date' => 'getDate',
        'user' => 'getUser',
        'client' => 'getClient',
        'status' => 'getStatus',
        'type' => 'getType',
        'path' => 'getPath',
        'description' => 'getDescription'
    );

    
    /**
      * $change The changelist ID
      * @var string
      */
    protected $change;
    
    /**
      * $date Last modification time of the changelist
      * @var \DateTime
      */
    protected $date;
    
    /**
      * $user The owner of the changelist
      * @var string
      */
    protected $user;
    
    /**
      * $client Name of current client workspace.
      * @var string
      */
    protected $client;
    
    /**
      * $status `pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.
      * @var string
      */
    protected $status;
    
    /**
      * $type Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.
      * @var string
      */
    protected $type;
    
    /**
      * $path Depot paths affected by this changelist
      * @var string
      */
    protected $path;
    
    /**
      * $description Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.
      * @var string
      */
    protected $description;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["change"])) {
              $this->change = $data["change"];
            }
            if (isset($data["date"])) {
              $this->date = $data["date"];
            }
            if (isset($data["user"])) {
              $this->user = $data["user"];
            }
            if (isset($data["client"])) {
              $this->client = $data["client"];
            }
            if (isset($data["status"])) {
              $this->status = $data["status"];
            }
            if (isset($data["type"])) {
              $this->type = $data["type"];
            }
            if (isset($data["path"])) {
              $this->path = $data["path"];
            }
            if (isset($data["description"])) {
              $this->description = $data["description"];
            }
        }
    }
    
    /**
     * Gets change
     * @return string
     */
    public function getChange()
    {
        return $this->change;
    }

    /**
     * Sets change
     * @param string $change The changelist ID
     * @return $this
     */
    public function setChange($change)
    {
        
        $this->change = $change;
        return $this;
    }
    
    /**
     * Gets date
     * @return \DateTime
     */
    public function getDate()
    {
        return $this->date;
    }

    /**
     * Sets date
     * @param \DateTime $date Last modification time of the changelist
     * @return $this
     */
    public function setDate($date)
    {
        
        $this->date = $date;
        return $this;
    }
    
    /**
     * Gets user
     * @return string
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Sets user
     * @param string $user The owner of the changelist
     * @return $this
     */
    public function setUser($user)
    {
        
        $this->user = $user;
        return $this;
    }
    
    /**
     * Gets client
     * @return string
     */
    public function getClient()
    {
        return $this->client;
    }

    /**
     * Sets client
     * @param string $client Name of current client workspace.
     * @return $this
     */
    public function setClient($client)
    {
        
        $this->client = $client;
        return $this;
    }
    
    /**
     * Gets status
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Sets status
     * @param string $status `pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.
     * @return $this
     */
    public function setStatus($status)
    {
        
        $this->status = $status;
        return $this;
    }
    
    /**
     * Gets type
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Sets type
     * @param string $type Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.
     * @return $this
     */
    public function setType($type)
    {
        
        $this->type = $type;
        return $this;
    }
    
    /**
     * Gets path
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * Sets path
     * @param string $path Depot paths affected by this changelist
     * @return $this
     */
    public function setPath($path)
    {
        
        $this->path = $path;
        return $this;
    }
    
    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets description
     * @param string $description Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.
     * @return $this
     */
    public function setDescription($description)
    {
        
        $this->description = $description;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
