<?php
/**
 * GroupCommand
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * GroupCommand Class Doc Comment
 *
 * @category    Class
 * @description Add or delete users from a group, or set the maxresults, maxscanrows, maxlocktime, and timeout limits for the members of a group.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GroupCommand implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'group' => 'string',
        'max_results' => 'string',
        'max_scan_rows' => 'string',
        'max_lock_time' => 'string',
        'max_open_files' => 'string',
        'timeout' => 'string',
        'password_timeout' => 'string',
        'ldap_config' => 'string',
        'ldap_search_query' => 'string',
        'ldap_user_attribute' => 'string',
        'subgroups' => 'string[]',
        'owners' => 'string[]',
        'users' => 'string[]'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'group' => 'group',
        'max_results' => 'maxResults',
        'max_scan_rows' => 'maxScanRows',
        'max_lock_time' => 'maxLockTime',
        'max_open_files' => 'maxOpenFiles',
        'timeout' => 'timeout',
        'password_timeout' => 'passwordTimeout',
        'ldap_config' => 'ldapConfig',
        'ldap_search_query' => 'ldapSearchQuery',
        'ldap_user_attribute' => 'ldapUserAttribute',
        'subgroups' => 'subgroups',
        'owners' => 'owners',
        'users' => 'users'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'group' => 'setGroup',
        'max_results' => 'setMaxResults',
        'max_scan_rows' => 'setMaxScanRows',
        'max_lock_time' => 'setMaxLockTime',
        'max_open_files' => 'setMaxOpenFiles',
        'timeout' => 'setTimeout',
        'password_timeout' => 'setPasswordTimeout',
        'ldap_config' => 'setLdapConfig',
        'ldap_search_query' => 'setLdapSearchQuery',
        'ldap_user_attribute' => 'setLdapUserAttribute',
        'subgroups' => 'setSubgroups',
        'owners' => 'setOwners',
        'users' => 'setUsers'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'group' => 'getGroup',
        'max_results' => 'getMaxResults',
        'max_scan_rows' => 'getMaxScanRows',
        'max_lock_time' => 'getMaxLockTime',
        'max_open_files' => 'getMaxOpenFiles',
        'timeout' => 'getTimeout',
        'password_timeout' => 'getPasswordTimeout',
        'ldap_config' => 'getLdapConfig',
        'ldap_search_query' => 'getLdapSearchQuery',
        'ldap_user_attribute' => 'getLdapUserAttribute',
        'subgroups' => 'getSubgroups',
        'owners' => 'getOwners',
        'users' => 'getUsers'
    );

    
    /**
      * $group The name of the group, as entered on the command line.
      * @var string
      */
    protected $group;
    
    /**
      * $max_results The maximum number of results that members of this group can access from the service from a single command.\nThe default value is `unset`.
      * @var string
      */
    protected $max_results;
    
    /**
      * $max_scan_rows The maximum number of rows that members of this group can scan from the service from a single command.\nThe default value is `unset`.
      * @var string
      */
    protected $max_scan_rows;
    
    /**
      * $max_lock_time The maximum length of time (in milliseconds) that any one operation can lock any database table when scanning data.\nThe default value is `unset`.
      * @var string
      */
    protected $max_lock_time;
    
    /**
      * $max_open_files The maximum number of files that a member of a group can open using a single command.
      * @var string
      */
    protected $max_open_files;
    
    /**
      * $timeout The duration (in seconds) of the validity of a session ticket created by p4 login.\nThe default value is 43,200 seconds (12 hours).\nTo create a ticket that does not expire, set the Timeout: field to `unlimited`.
      * @var string
      */
    protected $timeout;
    
    /**
      * $password_timeout The length of time (in seconds) for which passwords for users in this group remain valid.\nTo disable password aging, use a value of unset.
      * @var string
      */
    protected $password_timeout;
    
    /**
      * $ldap_config The LDAP configuration to use when populating the group’s user list from an LDAP query.
      * @var string
      */
    protected $ldap_config;
    
    /**
      * $ldap_search_query The LDAP query used to identify the members of the group.
      * @var string
      */
    protected $ldap_search_query;
    
    /**
      * $ldap_user_attribute The LDAP attribute that represents the user’s username.
      * @var string
      */
    protected $ldap_user_attribute;
    
    /**
      * $subgroups Names of other Perforce groups.\n\nTo add all users in a previously defined group to the group you’re presently working with, include the group name in the Subgroups: field of the p4 group form.\nNote that user and group names occupy separate namespaces, and thus, groups and users can have the same names.\n\nEvery member of any previously defined group you list in the Subgroups: field will be a member of the group you’re now defining.
      * @var string[]
      */
    protected $subgroups;
    
    /**
      * $owners Names of other Perforce users.\n\n  Group owners without super access are permitted to administer this group, provided that they use the -a option.\n\n  Group owners are not necessarily members of a group; if a group owner is to be a member of the group, the userid must also be added to the Users: field.\n\n  The specified owner does not have to be a Perforce user.\n  You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.
      * @var string[]
      */
    protected $owners;
    
    /**
      * $users The Perforce usernames of the group members.
      * @var string[]
      */
    protected $users;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["group"])) {
              $this->group = $data["group"];
            }
            if (isset($data["max_results"])) {
              $this->max_results = $data["max_results"];
            }
            if (isset($data["max_scan_rows"])) {
              $this->max_scan_rows = $data["max_scan_rows"];
            }
            if (isset($data["max_lock_time"])) {
              $this->max_lock_time = $data["max_lock_time"];
            }
            if (isset($data["max_open_files"])) {
              $this->max_open_files = $data["max_open_files"];
            }
            if (isset($data["timeout"])) {
              $this->timeout = $data["timeout"];
            }
            if (isset($data["password_timeout"])) {
              $this->password_timeout = $data["password_timeout"];
            }
            if (isset($data["ldap_config"])) {
              $this->ldap_config = $data["ldap_config"];
            }
            if (isset($data["ldap_search_query"])) {
              $this->ldap_search_query = $data["ldap_search_query"];
            }
            if (isset($data["ldap_user_attribute"])) {
              $this->ldap_user_attribute = $data["ldap_user_attribute"];
            }
            if (isset($data["subgroups"])) {
              $this->subgroups = $data["subgroups"];
            }
            if (isset($data["owners"])) {
              $this->owners = $data["owners"];
            }
            if (isset($data["users"])) {
              $this->users = $data["users"];
            }
        }
    }
    
    /**
     * Gets group
     * @return string
     */
    public function getGroup()
    {
        return $this->group;
    }

    /**
     * Sets group
     * @param string $group The name of the group, as entered on the command line.
     * @return $this
     */
    public function setGroup($group)
    {
        
        $this->group = $group;
        return $this;
    }
    
    /**
     * Gets max_results
     * @return string
     */
    public function getMaxResults()
    {
        return $this->max_results;
    }

    /**
     * Sets max_results
     * @param string $max_results The maximum number of results that members of this group can access from the service from a single command.\nThe default value is `unset`.
     * @return $this
     */
    public function setMaxResults($max_results)
    {
        
        $this->max_results = $max_results;
        return $this;
    }
    
    /**
     * Gets max_scan_rows
     * @return string
     */
    public function getMaxScanRows()
    {
        return $this->max_scan_rows;
    }

    /**
     * Sets max_scan_rows
     * @param string $max_scan_rows The maximum number of rows that members of this group can scan from the service from a single command.\nThe default value is `unset`.
     * @return $this
     */
    public function setMaxScanRows($max_scan_rows)
    {
        
        $this->max_scan_rows = $max_scan_rows;
        return $this;
    }
    
    /**
     * Gets max_lock_time
     * @return string
     */
    public function getMaxLockTime()
    {
        return $this->max_lock_time;
    }

    /**
     * Sets max_lock_time
     * @param string $max_lock_time The maximum length of time (in milliseconds) that any one operation can lock any database table when scanning data.\nThe default value is `unset`.
     * @return $this
     */
    public function setMaxLockTime($max_lock_time)
    {
        
        $this->max_lock_time = $max_lock_time;
        return $this;
    }
    
    /**
     * Gets max_open_files
     * @return string
     */
    public function getMaxOpenFiles()
    {
        return $this->max_open_files;
    }

    /**
     * Sets max_open_files
     * @param string $max_open_files The maximum number of files that a member of a group can open using a single command.
     * @return $this
     */
    public function setMaxOpenFiles($max_open_files)
    {
        
        $this->max_open_files = $max_open_files;
        return $this;
    }
    
    /**
     * Gets timeout
     * @return string
     */
    public function getTimeout()
    {
        return $this->timeout;
    }

    /**
     * Sets timeout
     * @param string $timeout The duration (in seconds) of the validity of a session ticket created by p4 login.\nThe default value is 43,200 seconds (12 hours).\nTo create a ticket that does not expire, set the Timeout: field to `unlimited`.
     * @return $this
     */
    public function setTimeout($timeout)
    {
        
        $this->timeout = $timeout;
        return $this;
    }
    
    /**
     * Gets password_timeout
     * @return string
     */
    public function getPasswordTimeout()
    {
        return $this->password_timeout;
    }

    /**
     * Sets password_timeout
     * @param string $password_timeout The length of time (in seconds) for which passwords for users in this group remain valid.\nTo disable password aging, use a value of unset.
     * @return $this
     */
    public function setPasswordTimeout($password_timeout)
    {
        
        $this->password_timeout = $password_timeout;
        return $this;
    }
    
    /**
     * Gets ldap_config
     * @return string
     */
    public function getLdapConfig()
    {
        return $this->ldap_config;
    }

    /**
     * Sets ldap_config
     * @param string $ldap_config The LDAP configuration to use when populating the group’s user list from an LDAP query.
     * @return $this
     */
    public function setLdapConfig($ldap_config)
    {
        
        $this->ldap_config = $ldap_config;
        return $this;
    }
    
    /**
     * Gets ldap_search_query
     * @return string
     */
    public function getLdapSearchQuery()
    {
        return $this->ldap_search_query;
    }

    /**
     * Sets ldap_search_query
     * @param string $ldap_search_query The LDAP query used to identify the members of the group.
     * @return $this
     */
    public function setLdapSearchQuery($ldap_search_query)
    {
        
        $this->ldap_search_query = $ldap_search_query;
        return $this;
    }
    
    /**
     * Gets ldap_user_attribute
     * @return string
     */
    public function getLdapUserAttribute()
    {
        return $this->ldap_user_attribute;
    }

    /**
     * Sets ldap_user_attribute
     * @param string $ldap_user_attribute The LDAP attribute that represents the user’s username.
     * @return $this
     */
    public function setLdapUserAttribute($ldap_user_attribute)
    {
        
        $this->ldap_user_attribute = $ldap_user_attribute;
        return $this;
    }
    
    /**
     * Gets subgroups
     * @return string[]
     */
    public function getSubgroups()
    {
        return $this->subgroups;
    }

    /**
     * Sets subgroups
     * @param string[] $subgroups Names of other Perforce groups.\n\nTo add all users in a previously defined group to the group you’re presently working with, include the group name in the Subgroups: field of the p4 group form.\nNote that user and group names occupy separate namespaces, and thus, groups and users can have the same names.\n\nEvery member of any previously defined group you list in the Subgroups: field will be a member of the group you’re now defining.
     * @return $this
     */
    public function setSubgroups($subgroups)
    {
        
        $this->subgroups = $subgroups;
        return $this;
    }
    
    /**
     * Gets owners
     * @return string[]
     */
    public function getOwners()
    {
        return $this->owners;
    }

    /**
     * Sets owners
     * @param string[] $owners Names of other Perforce users.\n\n  Group owners without super access are permitted to administer this group, provided that they use the -a option.\n\n  Group owners are not necessarily members of a group; if a group owner is to be a member of the group, the userid must also be added to the Users: field.\n\n  The specified owner does not have to be a Perforce user.\n  You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.
     * @return $this
     */
    public function setOwners($owners)
    {
        
        $this->owners = $owners;
        return $this;
    }
    
    /**
     * Gets users
     * @return string[]
     */
    public function getUsers()
    {
        return $this->users;
    }

    /**
     * Sets users
     * @param string[] $users The Perforce usernames of the group members.
     * @return $this
     */
    public function setUsers($users)
    {
        
        $this->users = $users;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
