<?php
/**
 * ServerCommand
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * ServerCommand Class Doc Comment
 *
 * @category    Class
 * @description The Perforce server specification describes the high-level configuration and intended usage of a Perforce server.\nFor installations with only one Perforce server, the server specification is optional.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ServerCommand implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'server_id' => 'string',
        'type' => 'string',
        'services' => 'string',
        'name' => 'string',
        'address' => 'string',
        'external_address' => 'string',
        'description' => 'string',
        'user' => 'string',
        'client_data_filter' => 'string',
        'revision_data_filter' => 'string',
        'archive_data_filter' => 'string',
        'distributed_config' => 'string'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'server_id' => 'serverID',
        'type' => 'type',
        'services' => 'services',
        'name' => 'name',
        'address' => 'address',
        'external_address' => 'externalAddress',
        'description' => 'description',
        'user' => 'user',
        'client_data_filter' => 'clientDataFilter',
        'revision_data_filter' => 'revisionDataFilter',
        'archive_data_filter' => 'archiveDataFilter',
        'distributed_config' => 'distributedConfig'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'server_id' => 'setServerId',
        'type' => 'setType',
        'services' => 'setServices',
        'name' => 'setName',
        'address' => 'setAddress',
        'external_address' => 'setExternalAddress',
        'description' => 'setDescription',
        'user' => 'setUser',
        'client_data_filter' => 'setClientDataFilter',
        'revision_data_filter' => 'setRevisionDataFilter',
        'archive_data_filter' => 'setArchiveDataFilter',
        'distributed_config' => 'setDistributedConfig'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'server_id' => 'getServerId',
        'type' => 'getType',
        'services' => 'getServices',
        'name' => 'getName',
        'address' => 'getAddress',
        'external_address' => 'getExternalAddress',
        'description' => 'getDescription',
        'user' => 'getUser',
        'client_data_filter' => 'getClientDataFilter',
        'revision_data_filter' => 'getRevisionDataFilter',
        'archive_data_filter' => 'getArchiveDataFilter',
        'distributed_config' => 'getDistributedConfig'
    );

    
    /**
      * $server_id A unique identifier for this server.\nThis must match the contents of the server’s `server.id` file as defined by the p4 serverid command.\nIf the server type is identifier, the server id specifies the name of the cluster.
      * @var string
      */
    protected $server_id;
    
    /**
      * $type Server executable type.\n\nOne of the following: `server`, `proxy`, `broker`, `identifier`, `admin`.\n\nEach type may offer one or more services, defined in the `services` property.
      * @var string
      */
    protected $type;
    
    /**
      * $services The `server` type server provides the following services:\n\n- standard - a standard Perforce server\n- replica - a read-only replica server\n- commit-server - central server in distributed installation\n- edge-server - node in distributed installation\n- forwarding-replica - a replica configured to forward commands that involve database writes to a master server\n- build-server - a replica that supports build automation and build farm integration\n- P4AUTH - a server that provides authentication\n- P4CHANGE - a server that provides change numbering\n- depot-master - commit-server with automated failover\n- depot-standby - standby replica of the depot-master\n- workspace-server - node in a cluster installation\n- standby - read-only replica server that uses p4 journalcopy\n- forwarding-standby - forwarding replica server that uses p4 journalcopy\n\nThe `proxy` type server provides a p4p caching proxy.\n\nThe `broker` type server provides the following services:\n\n- broker - a p4broker process\n- workspace-router - routing broker for a cluster\n\nThe services field for the `identifier` type server specifies the existence of the cluster, and has the value `cluster`.\nThe name of the cluster is then drawn from the ServerID field.\n\nThe `admin` type server provides the following services:\n\n- hxca-server - the admin server for a Helix cluster.\n- zookeeper-server - ZooKeeper server for a cluster
      * @var string
      */
    protected $services;
    
    /**
      * $name The P4NAME associated with this server.\nYou can leave this blank or you can set it to the same value as the serverid.
      * @var string
      */
    protected $name;
    
    /**
      * $address The P4PORT used by this server.
      * @var string
      */
    protected $address;
    
    /**
      * $external_address For an edge server, this optional field specifies the external address used for connections to a commit server.\nThis field must be set for the edge server to enable parallel submits in a federated environment.
      * @var string
      */
    protected $external_address;
    
    /**
      * $description An optional description for this server.
      * @var string
      */
    protected $description;
    
    /**
      * $user The service user name used by the server.
      * @var string
      */
    protected $user;
    
    /**
      * $client_data_filter For a replica server, this optional field can contain one or more patterns describing how active client workspace metadata is to be filtered. Active client workspace data includes have lists, working records, and pending resolves.\n\nTo include client data, use the syntax:\n`//client-pattern/...`\n\nTo exclude client data, use the syntax:\n`-//client-pattern/...`\n\nAll patterns are specified in client syntax.
      * @var string
      */
    protected $client_data_filter;
    
    /**
      * $revision_data_filter For a replica server, this optional field can contain one or more patterns describing how submitted revision metadata is to be filtered. Submitted revision data includes revision records, integration records, label contents, and the files listed in submitted changelists.\n\nTo include depot data, use the syntax:\n//depot/pattern/...\n\nTo exclude depot data, use the syntax:\n-//depot/pattern/...\n\nAll patterns are specified in depot syntax.
      * @var string
      */
    protected $revision_data_filter;
    
    /**
      * $archive_data_filter For a replica server, this optional field can contain one or more patterns describing the policy for automatically scheduling the replication of file content. If this field is present, only those files described by the pattern are automatically transferred to the replica; other files are not transferred until they are referenced by a replica command that needs the file content.\n\nFiles specified in the ArchiveDataFilter: field are transferred to the replica regardless of whether any users of the replica have made requests for their content.\n\nTo automatically transfer files on submit, use the syntax:\n`//depot/pattern/...`\n\nTo exclude files from automatic transfer, use the syntax:\n`-//depot/pattern/...`\n\nAll patterns are specified in depot syntax.
      * @var string
      */
    protected $archive_data_filter;
    
    /**
      * $distributed_config For an edge or commit server, this optional field, which is displayed only when you use the -l or -c option, shows configuration settings for this server.\n\n`-l` flag shows the current configuration.\n`-c-` flag shows current configuration values, recommended default values for fields that are not set, or unset for fields that are not set and do not have default values.\n\nIf this field is present when invoked with -c, the configuration commands in this field are run on the current server using the scope of the server specified in the serverID field.
      * @var string
      */
    protected $distributed_config;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["server_id"])) {
              $this->server_id = $data["server_id"];
            }
            if (isset($data["type"])) {
              $this->type = $data["type"];
            }
            if (isset($data["services"])) {
              $this->services = $data["services"];
            }
            if (isset($data["name"])) {
              $this->name = $data["name"];
            }
            if (isset($data["address"])) {
              $this->address = $data["address"];
            }
            if (isset($data["external_address"])) {
              $this->external_address = $data["external_address"];
            }
            if (isset($data["description"])) {
              $this->description = $data["description"];
            }
            if (isset($data["user"])) {
              $this->user = $data["user"];
            }
            if (isset($data["client_data_filter"])) {
              $this->client_data_filter = $data["client_data_filter"];
            }
            if (isset($data["revision_data_filter"])) {
              $this->revision_data_filter = $data["revision_data_filter"];
            }
            if (isset($data["archive_data_filter"])) {
              $this->archive_data_filter = $data["archive_data_filter"];
            }
            if (isset($data["distributed_config"])) {
              $this->distributed_config = $data["distributed_config"];
            }
        }
    }
    
    /**
     * Gets server_id
     * @return string
     */
    public function getServerId()
    {
        return $this->server_id;
    }

    /**
     * Sets server_id
     * @param string $server_id A unique identifier for this server.\nThis must match the contents of the server’s `server.id` file as defined by the p4 serverid command.\nIf the server type is identifier, the server id specifies the name of the cluster.
     * @return $this
     */
    public function setServerId($server_id)
    {
        
        $this->server_id = $server_id;
        return $this;
    }
    
    /**
     * Gets type
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Sets type
     * @param string $type Server executable type.\n\nOne of the following: `server`, `proxy`, `broker`, `identifier`, `admin`.\n\nEach type may offer one or more services, defined in the `services` property.
     * @return $this
     */
    public function setType($type)
    {
        
        $this->type = $type;
        return $this;
    }
    
    /**
     * Gets services
     * @return string
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * Sets services
     * @param string $services The `server` type server provides the following services:\n\n- standard - a standard Perforce server\n- replica - a read-only replica server\n- commit-server - central server in distributed installation\n- edge-server - node in distributed installation\n- forwarding-replica - a replica configured to forward commands that involve database writes to a master server\n- build-server - a replica that supports build automation and build farm integration\n- P4AUTH - a server that provides authentication\n- P4CHANGE - a server that provides change numbering\n- depot-master - commit-server with automated failover\n- depot-standby - standby replica of the depot-master\n- workspace-server - node in a cluster installation\n- standby - read-only replica server that uses p4 journalcopy\n- forwarding-standby - forwarding replica server that uses p4 journalcopy\n\nThe `proxy` type server provides a p4p caching proxy.\n\nThe `broker` type server provides the following services:\n\n- broker - a p4broker process\n- workspace-router - routing broker for a cluster\n\nThe services field for the `identifier` type server specifies the existence of the cluster, and has the value `cluster`.\nThe name of the cluster is then drawn from the ServerID field.\n\nThe `admin` type server provides the following services:\n\n- hxca-server - the admin server for a Helix cluster.\n- zookeeper-server - ZooKeeper server for a cluster
     * @return $this
     */
    public function setServices($services)
    {
        
        $this->services = $services;
        return $this;
    }
    
    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets name
     * @param string $name The P4NAME associated with this server.\nYou can leave this blank or you can set it to the same value as the serverid.
     * @return $this
     */
    public function setName($name)
    {
        
        $this->name = $name;
        return $this;
    }
    
    /**
     * Gets address
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Sets address
     * @param string $address The P4PORT used by this server.
     * @return $this
     */
    public function setAddress($address)
    {
        
        $this->address = $address;
        return $this;
    }
    
    /**
     * Gets external_address
     * @return string
     */
    public function getExternalAddress()
    {
        return $this->external_address;
    }

    /**
     * Sets external_address
     * @param string $external_address For an edge server, this optional field specifies the external address used for connections to a commit server.\nThis field must be set for the edge server to enable parallel submits in a federated environment.
     * @return $this
     */
    public function setExternalAddress($external_address)
    {
        
        $this->external_address = $external_address;
        return $this;
    }
    
    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets description
     * @param string $description An optional description for this server.
     * @return $this
     */
    public function setDescription($description)
    {
        
        $this->description = $description;
        return $this;
    }
    
    /**
     * Gets user
     * @return string
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Sets user
     * @param string $user The service user name used by the server.
     * @return $this
     */
    public function setUser($user)
    {
        
        $this->user = $user;
        return $this;
    }
    
    /**
     * Gets client_data_filter
     * @return string
     */
    public function getClientDataFilter()
    {
        return $this->client_data_filter;
    }

    /**
     * Sets client_data_filter
     * @param string $client_data_filter For a replica server, this optional field can contain one or more patterns describing how active client workspace metadata is to be filtered. Active client workspace data includes have lists, working records, and pending resolves.\n\nTo include client data, use the syntax:\n`//client-pattern/...`\n\nTo exclude client data, use the syntax:\n`-//client-pattern/...`\n\nAll patterns are specified in client syntax.
     * @return $this
     */
    public function setClientDataFilter($client_data_filter)
    {
        
        $this->client_data_filter = $client_data_filter;
        return $this;
    }
    
    /**
     * Gets revision_data_filter
     * @return string
     */
    public function getRevisionDataFilter()
    {
        return $this->revision_data_filter;
    }

    /**
     * Sets revision_data_filter
     * @param string $revision_data_filter For a replica server, this optional field can contain one or more patterns describing how submitted revision metadata is to be filtered. Submitted revision data includes revision records, integration records, label contents, and the files listed in submitted changelists.\n\nTo include depot data, use the syntax:\n//depot/pattern/...\n\nTo exclude depot data, use the syntax:\n-//depot/pattern/...\n\nAll patterns are specified in depot syntax.
     * @return $this
     */
    public function setRevisionDataFilter($revision_data_filter)
    {
        
        $this->revision_data_filter = $revision_data_filter;
        return $this;
    }
    
    /**
     * Gets archive_data_filter
     * @return string
     */
    public function getArchiveDataFilter()
    {
        return $this->archive_data_filter;
    }

    /**
     * Sets archive_data_filter
     * @param string $archive_data_filter For a replica server, this optional field can contain one or more patterns describing the policy for automatically scheduling the replication of file content. If this field is present, only those files described by the pattern are automatically transferred to the replica; other files are not transferred until they are referenced by a replica command that needs the file content.\n\nFiles specified in the ArchiveDataFilter: field are transferred to the replica regardless of whether any users of the replica have made requests for their content.\n\nTo automatically transfer files on submit, use the syntax:\n`//depot/pattern/...`\n\nTo exclude files from automatic transfer, use the syntax:\n`-//depot/pattern/...`\n\nAll patterns are specified in depot syntax.
     * @return $this
     */
    public function setArchiveDataFilter($archive_data_filter)
    {
        
        $this->archive_data_filter = $archive_data_filter;
        return $this;
    }
    
    /**
     * Gets distributed_config
     * @return string
     */
    public function getDistributedConfig()
    {
        return $this->distributed_config;
    }

    /**
     * Sets distributed_config
     * @param string $distributed_config For an edge or commit server, this optional field, which is displayed only when you use the -l or -c option, shows configuration settings for this server.\n\n`-l` flag shows the current configuration.\n`-c-` flag shows current configuration values, recommended default values for fields that are not set, or unset for fields that are not set and do not have default values.\n\nIf this field is present when invoked with -c, the configuration commands in this field are run on the current server using the scope of the server specified in the serverID field.
     * @return $this
     */
    public function setDistributedConfig($distributed_config)
    {
        
        $this->distributed_config = $distributed_config;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
