<?php
/**
 * Triggers
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * Triggers Class Doc Comment
 *
 * @category    Class
 * @description Defines the triggers table, like it would appear in the output to the `p4 triggers` command.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Triggers implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'triggers' => 'string[]'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'triggers' => 'triggers'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'triggers' => 'setTriggers'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'triggers' => 'getTriggers'
    );

    
    /**
      * $triggers A list of trigger definitions.\n\nA trigger definition contains four fields that specify the name of the trigger, the type of event that should trigger the execution of the script, the paths that should be affected by the trigger, the location of the script, and other trigger type-dependent information.\nWhen the condition specified in a trigger definition is satisfied, the associated script or program is executed.\n\nExample: `trig1 change-submit //depot/dir/...   \"/usr/bin/s1.pl %changelist%\"`\n\nSee the Helix Versioning Engine Administrator Guide for more details on trigger definitions.
      * @var string[]
      */
    protected $triggers;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["triggers"])) {
              $this->triggers = $data["triggers"];
            }
        }
    }
    
    /**
     * Gets triggers
     * @return string[]
     */
    public function getTriggers()
    {
        return $this->triggers;
    }

    /**
     * Sets triggers
     * @param string[] $triggers A list of trigger definitions.\n\nA trigger definition contains four fields that specify the name of the trigger, the type of event that should trigger the execution of the script, the paths that should be affected by the trigger, the location of the script, and other trigger type-dependent information.\nWhen the condition specified in a trigger definition is satisfied, the associated script or program is executed.\n\nExample: `trig1 change-submit //depot/dir/...   \"/usr/bin/s1.pl %changelist%\"`\n\nSee the Helix Versioning Engine Administrator Guide for more details on trigger definitions.
     * @return $this
     */
    public function setTriggers($triggers)
    {
        
        $this->triggers = $triggers;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
