# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GitFusionRepoGlobalOverrides(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GitFusionRepoGlobalOverrides - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'charset': 'str',
            'depot_path_repo_creation_enable': 'str',
            'depot_path_repo_creation_p4group': 'str',
            'change_owner': 'str',
            'enable_git_branch_creation': 'str',
            'enable_swarm_reviews': 'str',
            'enable_git_merge_commits': 'str',
            'enable_git_submodules': 'str',
            'ignore_author_permissions': 'str',
            'preflight_commit': 'str',
            'read_permission_check': 'str',
            'git_merge_avoidance_after_change_num': 'str',
            'job_lookup': 'str',
            'depot_branch_creation_enable': 'str',
            'depot_branch_creation_p4group': 'str',
            'depot_branch_creation_depot_path': 'str',
            'depot_branch_creation_view': 'str',
            'enable_git_find_copies': 'str',
            'enable_git_find_renames': 'str',
            'enable_stream_imports': 'str',
            'http_url': 'str',
            'ssh_url': 'str',
            'email_case_sensitivity': 'str',
            'author_source': 'str',
            'limit_space_mb': 'str',
            'limit_commits_received': 'str',
            'limit_files_received': 'str',
            'limit_megabytes_received': 'str'
        }

        self.attribute_map = {
            'charset': 'charset',
            'depot_path_repo_creation_enable': 'depotPathRepoCreationEnable',
            'depot_path_repo_creation_p4group': 'depotPathRepoCreationP4group',
            'change_owner': 'changeOwner',
            'enable_git_branch_creation': 'enableGitBranchCreation',
            'enable_swarm_reviews': 'enableSwarmReviews',
            'enable_git_merge_commits': 'enableGitMergeCommits',
            'enable_git_submodules': 'enableGitSubmodules',
            'ignore_author_permissions': 'ignoreAuthorPermissions',
            'preflight_commit': 'preflightCommit',
            'read_permission_check': 'readPermissionCheck',
            'git_merge_avoidance_after_change_num': 'gitMergeAvoidanceAfterChangeNum',
            'job_lookup': 'jobLookup',
            'depot_branch_creation_enable': 'depotBranchCreationEnable',
            'depot_branch_creation_p4group': 'depotBranchCreationP4group',
            'depot_branch_creation_depot_path': 'depotBranchCreationDepotPath',
            'depot_branch_creation_view': 'depotBranchCreationView',
            'enable_git_find_copies': 'enableGitFindCopies',
            'enable_git_find_renames': 'enableGitFindRenames',
            'enable_stream_imports': 'enableStreamImports',
            'http_url': 'httpUrl',
            'ssh_url': 'sshUrl',
            'email_case_sensitivity': 'emailCaseSensitivity',
            'author_source': 'authorSource',
            'limit_space_mb': 'limitSpaceMb',
            'limit_commits_received': 'limitCommitsReceived',
            'limit_files_received': 'limitFilesReceived',
            'limit_megabytes_received': 'limitMegabytesReceived'
        }

        self._charset = None
        self._depot_path_repo_creation_enable = None
        self._depot_path_repo_creation_p4group = None
        self._change_owner = None
        self._enable_git_branch_creation = None
        self._enable_swarm_reviews = None
        self._enable_git_merge_commits = None
        self._enable_git_submodules = None
        self._ignore_author_permissions = None
        self._preflight_commit = None
        self._read_permission_check = None
        self._git_merge_avoidance_after_change_num = None
        self._job_lookup = None
        self._depot_branch_creation_enable = None
        self._depot_branch_creation_p4group = None
        self._depot_branch_creation_depot_path = None
        self._depot_branch_creation_view = None
        self._enable_git_find_copies = None
        self._enable_git_find_renames = None
        self._enable_stream_imports = None
        self._http_url = None
        self._ssh_url = None
        self._email_case_sensitivity = None
        self._author_source = None
        self._limit_space_mb = None
        self._limit_commits_received = None
        self._limit_files_received = None
        self._limit_megabytes_received = None

    @property
    def charset(self):
        """
        Gets the charset of this GitFusionRepoGlobalOverrides.
        Defines the default Unicode setting that Git Fusion applies to new repos.\nThis setting is valid only when Git Fusion interacts with a Unicode-enabled Perforce server.\n\n(Defaults to `UTF-8`).

        :return: The charset of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._charset

    @charset.setter
    def charset(self, charset):
        """
        Sets the charset of this GitFusionRepoGlobalOverrides.
        Defines the default Unicode setting that Git Fusion applies to new repos.\nThis setting is valid only when Git Fusion interacts with a Unicode-enabled Perforce server.\n\n(Defaults to `UTF-8`).

        :param charset: The charset of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._charset = charset

    @property
    def depot_path_repo_creation_enable(self):
        """
        Gets the depot_path_repo_creation_enable of this GitFusionRepoGlobalOverrides.
        Allow Git users to create new repos by pushing/pulling a git url which specifies a Perforce depot path.\nThis is similar to creating a repo from a p4 client.

        :return: The depot_path_repo_creation_enable of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_path_repo_creation_enable

    @depot_path_repo_creation_enable.setter
    def depot_path_repo_creation_enable(self, depot_path_repo_creation_enable):
        """
        Sets the depot_path_repo_creation_enable of this GitFusionRepoGlobalOverrides.
        Allow Git users to create new repos by pushing/pulling a git url which specifies a Perforce depot path.\nThis is similar to creating a repo from a p4 client.

        :param depot_path_repo_creation_enable: The depot_path_repo_creation_enable of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_path_repo_creation_enable = depot_path_repo_creation_enable

    @property
    def depot_path_repo_creation_p4group(self):
        """
        Gets the depot_path_repo_creation_p4group of this GitFusionRepoGlobalOverrides.
        Restrict which authenticated Git pushers are allowed to create new repos when depot-path-repo-creation-enable is enabled.

        :return: The depot_path_repo_creation_p4group of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_path_repo_creation_p4group

    @depot_path_repo_creation_p4group.setter
    def depot_path_repo_creation_p4group(self, depot_path_repo_creation_p4group):
        """
        Sets the depot_path_repo_creation_p4group of this GitFusionRepoGlobalOverrides.
        Restrict which authenticated Git pushers are allowed to create new repos when depot-path-repo-creation-enable is enabled.

        :param depot_path_repo_creation_p4group: The depot_path_repo_creation_p4group of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_path_repo_creation_p4group = depot_path_repo_creation_p4group

    @property
    def change_owner(self):
        """
        Gets the change_owner of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion assigns either the Git commit author or the Git pusher as the owner of a pushed change (submit).

        :return: The change_owner of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._change_owner

    @change_owner.setter
    def change_owner(self, change_owner):
        """
        Sets the change_owner of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion assigns either the Git commit author or the Git pusher as the owner of a pushed change (submit).

        :param change_owner: The change_owner of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._change_owner = change_owner

    @property
    def enable_git_branch_creation(self):
        """
        Gets the enable_git_branch_creation of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion creates a new branch of Perforce depot file hierarchy for each copied branch of Git workspace history, including Git task branches as Git Fusion anonymous branches.

        :return: The enable_git_branch_creation of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_git_branch_creation

    @enable_git_branch_creation.setter
    def enable_git_branch_creation(self, enable_git_branch_creation):
        """
        Sets the enable_git_branch_creation of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion creates a new branch of Perforce depot file hierarchy for each copied branch of Git workspace history, including Git task branches as Git Fusion anonymous branches.

        :param enable_git_branch_creation: The enable_git_branch_creation of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_git_branch_creation = enable_git_branch_creation

    @property
    def enable_swarm_reviews(self):
        """
        Gets the enable_swarm_reviews of this GitFusionRepoGlobalOverrides.
        Permits branch creation for Swarm reviews, even when enable-git-branch-creation is disabled.

        :return: The enable_swarm_reviews of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_swarm_reviews

    @enable_swarm_reviews.setter
    def enable_swarm_reviews(self, enable_swarm_reviews):
        """
        Sets the enable_swarm_reviews of this GitFusionRepoGlobalOverrides.
        Permits branch creation for Swarm reviews, even when enable-git-branch-creation is disabled.

        :param enable_swarm_reviews: The enable_swarm_reviews of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_swarm_reviews = enable_swarm_reviews

    @property
    def enable_git_merge_commits(self):
        """
        Gets the enable_git_merge_commits of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion copies merge commits and displays them in Perforce as integrations between Perforce branches.

        :return: The enable_git_merge_commits of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_git_merge_commits

    @enable_git_merge_commits.setter
    def enable_git_merge_commits(self, enable_git_merge_commits):
        """
        Sets the enable_git_merge_commits of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion copies merge commits and displays them in Perforce as integrations between Perforce branches.

        :param enable_git_merge_commits: The enable_git_merge_commits of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_git_merge_commits = enable_git_merge_commits

    @property
    def enable_git_submodules(self):
        """
        Gets the enable_git_submodules of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion allows Git submodules to be pushed to Perforce.

        :return: The enable_git_submodules of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_git_submodules

    @enable_git_submodules.setter
    def enable_git_submodules(self, enable_git_submodules):
        """
        Sets the enable_git_submodules of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion allows Git submodules to be pushed to Perforce.

        :param enable_git_submodules: The enable_git_submodules of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_git_submodules = enable_git_submodules

    @property
    def ignore_author_permissions(self):
        """
        Gets the ignore_author_permissions of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion evaluates both the author's and pusher's Perforce write permissions during a push or evaluates only the pusher's permissions.

        :return: The ignore_author_permissions of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._ignore_author_permissions

    @ignore_author_permissions.setter
    def ignore_author_permissions(self, ignore_author_permissions):
        """
        Sets the ignore_author_permissions of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion evaluates both the author's and pusher's Perforce write permissions during a push or evaluates only the pusher's permissions.

        :param ignore_author_permissions: The ignore_author_permissions of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._ignore_author_permissions = ignore_author_permissions

    @property
    def preflight_commit(self):
        """
        Gets the preflight_commit of this GitFusionRepoGlobalOverrides.
        Enables you to trigger pre-flight commit scripts that enforce local policy for Git pushes. This can be especially useful if you have Perforce submit triggers that could reject a push and damage the repository.

        :return: The preflight_commit of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._preflight_commit

    @preflight_commit.setter
    def preflight_commit(self, preflight_commit):
        """
        Sets the preflight_commit of this GitFusionRepoGlobalOverrides.
        Enables you to trigger pre-flight commit scripts that enforce local policy for Git pushes. This can be especially useful if you have Perforce submit triggers that could reject a push and damage the repository.

        :param preflight_commit: The preflight_commit of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._preflight_commit = preflight_commit

    @property
    def read_permission_check(self):
        """
        Gets the read_permission_check of this GitFusionRepoGlobalOverrides.
        Enables you to require that Git clone, pull, or fetch requests check the Perforce protections table for the puller's read permission on the files being pulled.

        :return: The read_permission_check of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._read_permission_check

    @read_permission_check.setter
    def read_permission_check(self, read_permission_check):
        """
        Sets the read_permission_check of this GitFusionRepoGlobalOverrides.
        Enables you to require that Git clone, pull, or fetch requests check the Perforce protections table for the puller's read permission on the files being pulled.

        :param read_permission_check: The read_permission_check of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._read_permission_check = read_permission_check

    @property
    def git_merge_avoidance_after_change_num(self):
        """
        Gets the git_merge_avoidance_after_change_num of this GitFusionRepoGlobalOverrides.
        If the Perforce service includes any changelists submitted by Git Fusion 13.2 or earlier, you can prevent unnecessary merge commits by setting this key to the number of the last changelist submitted before your site upgraded to a later version of Git Fusion.

        :return: The git_merge_avoidance_after_change_num of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._git_merge_avoidance_after_change_num

    @git_merge_avoidance_after_change_num.setter
    def git_merge_avoidance_after_change_num(self, git_merge_avoidance_after_change_num):
        """
        Sets the git_merge_avoidance_after_change_num of this GitFusionRepoGlobalOverrides.
        If the Perforce service includes any changelists submitted by Git Fusion 13.2 or earlier, you can prevent unnecessary merge commits by setting this key to the number of the last changelist submitted before your site upgraded to a later version of Git Fusion.

        :param git_merge_avoidance_after_change_num: The git_merge_avoidance_after_change_num of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._git_merge_avoidance_after_change_num = git_merge_avoidance_after_change_num

    @property
    def job_lookup(self):
        """
        Gets the job_lookup of this GitFusionRepoGlobalOverrides.
        Set the format for entering Perforce jobs in Git commit descriptions so that they are recognized by Git Fusion and appear in Perforce changelists as fixes.\nBy default, job IDs whose string starts with \"job\" (as in job123456) are passed through to the changelist description and job field.\nUse this option if you want Git Fusion to recognize additional expressions, such as JIRA issue IDs.

        :return: The job_lookup of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._job_lookup

    @job_lookup.setter
    def job_lookup(self, job_lookup):
        """
        Sets the job_lookup of this GitFusionRepoGlobalOverrides.
        Set the format for entering Perforce jobs in Git commit descriptions so that they are recognized by Git Fusion and appear in Perforce changelists as fixes.\nBy default, job IDs whose string starts with \"job\" (as in job123456) are passed through to the changelist description and job field.\nUse this option if you want Git Fusion to recognize additional expressions, such as JIRA issue IDs.

        :param job_lookup: The job_lookup of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._job_lookup = job_lookup

    @property
    def depot_branch_creation_enable(self):
        """
        Gets the depot_branch_creation_enable of this GitFusionRepoGlobalOverrides.
        Allow Git users to create new fully-populated depot branches within Perforce.

        :return: The depot_branch_creation_enable of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_branch_creation_enable

    @depot_branch_creation_enable.setter
    def depot_branch_creation_enable(self, depot_branch_creation_enable):
        """
        Sets the depot_branch_creation_enable of this GitFusionRepoGlobalOverrides.
        Allow Git users to create new fully-populated depot branches within Perforce.

        :param depot_branch_creation_enable: The depot_branch_creation_enable of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_branch_creation_enable = depot_branch_creation_enable

    @property
    def depot_branch_creation_p4group(self):
        """
        Gets the depot_branch_creation_p4group of this GitFusionRepoGlobalOverrides.
        Restrict the authenticated Git pushers who are allowed to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.

        :return: The depot_branch_creation_p4group of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_branch_creation_p4group

    @depot_branch_creation_p4group.setter
    def depot_branch_creation_p4group(self, depot_branch_creation_p4group):
        """
        Sets the depot_branch_creation_p4group of this GitFusionRepoGlobalOverrides.
        Restrict the authenticated Git pushers who are allowed to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.

        :param depot_branch_creation_p4group: The depot_branch_creation_p4group of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_branch_creation_p4group = depot_branch_creation_p4group

    @property
    def depot_branch_creation_depot_path(self):
        """
        Gets the depot_branch_creation_depot_path of this GitFusionRepoGlobalOverrides.
        Tell Git Fusion where to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.\n\nDefault path is `//depot/[repo]/[git_branch_name]`.

        :return: The depot_branch_creation_depot_path of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_branch_creation_depot_path

    @depot_branch_creation_depot_path.setter
    def depot_branch_creation_depot_path(self, depot_branch_creation_depot_path):
        """
        Sets the depot_branch_creation_depot_path of this GitFusionRepoGlobalOverrides.
        Tell Git Fusion where to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.\n\nDefault path is `//depot/[repo]/[git_branch_name]`.

        :param depot_branch_creation_depot_path: The depot_branch_creation_depot_path of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_branch_creation_depot_path = depot_branch_creation_depot_path

    @property
    def depot_branch_creation_view(self):
        """
        Gets the depot_branch_creation_view of this GitFusionRepoGlobalOverrides.
        Set how the depot path set in depotBranchCreationDepotPath should appear in Git.\n\nEnter a Perforce view specification that maps Perforce depot paths (left side) to Git work tree paths (right side).\nPerforce depot paths are relative to the root set in depotBranchCreationDepotPath.\n\nThe default `... ...` maps every file under the depotBranchCreationDepotPath root to Git.\nRight side paths must match the right side for every other branch already defined within a repo.

        :return: The depot_branch_creation_view of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._depot_branch_creation_view

    @depot_branch_creation_view.setter
    def depot_branch_creation_view(self, depot_branch_creation_view):
        """
        Sets the depot_branch_creation_view of this GitFusionRepoGlobalOverrides.
        Set how the depot path set in depotBranchCreationDepotPath should appear in Git.\n\nEnter a Perforce view specification that maps Perforce depot paths (left side) to Git work tree paths (right side).\nPerforce depot paths are relative to the root set in depotBranchCreationDepotPath.\n\nThe default `... ...` maps every file under the depotBranchCreationDepotPath root to Git.\nRight side paths must match the right side for every other branch already defined within a repo.

        :param depot_branch_creation_view: The depot_branch_creation_view of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._depot_branch_creation_view = depot_branch_creation_view

    @property
    def enable_git_find_copies(self):
        """
        Gets the enable_git_find_copies of this GitFusionRepoGlobalOverrides.
        When Git reports a copy file action, store that action in Perforce as a p4 integ.\nOften set in tandem with enableGitFindRenames.\n\nNo/Off/0%: Do not use Git's copy detection.\nTreat all possible file copy actions as p4 add actions.\n\n1%-100%: Use Git's copy detection. Value passed to git diff-tree --find-copies=n.\n\nGit Fusion also adds --find-copies-harder whenever adding --find-copies.

        :return: The enable_git_find_copies of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_git_find_copies

    @enable_git_find_copies.setter
    def enable_git_find_copies(self, enable_git_find_copies):
        """
        Sets the enable_git_find_copies of this GitFusionRepoGlobalOverrides.
        When Git reports a copy file action, store that action in Perforce as a p4 integ.\nOften set in tandem with enableGitFindRenames.\n\nNo/Off/0%: Do not use Git's copy detection.\nTreat all possible file copy actions as p4 add actions.\n\n1%-100%: Use Git's copy detection. Value passed to git diff-tree --find-copies=n.\n\nGit Fusion also adds --find-copies-harder whenever adding --find-copies.

        :param enable_git_find_copies: The enable_git_find_copies of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_git_find_copies = enable_git_find_copies

    @property
    def enable_git_find_renames(self):
        """
        Gets the enable_git_find_renames of this GitFusionRepoGlobalOverrides.
        When Git reports a rename (also called move) file action, store that in Perforce as a p4 move.\nOften set in tandem with enableGitFindCopies.\n\n`No`/`Off`/`0%`: Do not use Git's rename detection.\nTreat all possible file rename actions as independent p4 delete and p4 add actions.\n\n`1%`-`100%`: Use Git's rename detection.\nValue passed to git diff-tree --find-renames=n.

        :return: The enable_git_find_renames of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_git_find_renames

    @enable_git_find_renames.setter
    def enable_git_find_renames(self, enable_git_find_renames):
        """
        Sets the enable_git_find_renames of this GitFusionRepoGlobalOverrides.
        When Git reports a rename (also called move) file action, store that in Perforce as a p4 move.\nOften set in tandem with enableGitFindCopies.\n\n`No`/`Off`/`0%`: Do not use Git's rename detection.\nTreat all possible file rename actions as independent p4 delete and p4 add actions.\n\n`1%`-`100%`: Use Git's rename detection.\nValue passed to git diff-tree --find-renames=n.

        :param enable_git_find_renames: The enable_git_find_renames of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_git_find_renames = enable_git_find_renames

    @property
    def enable_stream_imports(self):
        """
        Gets the enable_stream_imports of this GitFusionRepoGlobalOverrides.
        Enables you to convert Perforce stream import paths to Git submodules when you clone a Git Fusion repository.\nIf set to Yes, you must also set either httpUrl or sshUrl.

        :return: The enable_stream_imports of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._enable_stream_imports

    @enable_stream_imports.setter
    def enable_stream_imports(self, enable_stream_imports):
        """
        Sets the enable_stream_imports of this GitFusionRepoGlobalOverrides.
        Enables you to convert Perforce stream import paths to Git submodules when you clone a Git Fusion repository.\nIf set to Yes, you must also set either httpUrl or sshUrl.

        :param enable_stream_imports: The enable_stream_imports of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._enable_stream_imports = enable_stream_imports

    @property
    def http_url(self):
        """
        Gets the http_url of this GitFusionRepoGlobalOverrides.
        The URL used by Git to clone a repository from Git Fusion over HTTP.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use HTTP(S).

        :return: The http_url of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._http_url

    @http_url.setter
    def http_url(self, http_url):
        """
        Sets the http_url of this GitFusionRepoGlobalOverrides.
        The URL used by Git to clone a repository from Git Fusion over HTTP.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use HTTP(S).

        :param http_url: The http_url of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._http_url = http_url

    @property
    def ssh_url(self):
        """
        Gets the ssh_url of this GitFusionRepoGlobalOverrides.
        The \"URL\" used by Git to clone a repository from Git Fusion using SSH.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use SSH.

        :return: The ssh_url of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._ssh_url

    @ssh_url.setter
    def ssh_url(self, ssh_url):
        """
        Sets the ssh_url of this GitFusionRepoGlobalOverrides.
        The \"URL\" used by Git to clone a repository from Git Fusion using SSH.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use SSH.

        :param ssh_url: The ssh_url of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._ssh_url = ssh_url

    @property
    def email_case_sensitivity(self):
        """
        Gets the email_case_sensitivity of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion pays attention to case when matching Git user email addresses to Perforce user account email addresses during the authorization check.

        :return: The email_case_sensitivity of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._email_case_sensitivity

    @email_case_sensitivity.setter
    def email_case_sensitivity(self, email_case_sensitivity):
        """
        Sets the email_case_sensitivity of this GitFusionRepoGlobalOverrides.
        Defines whether Git Fusion pays attention to case when matching Git user email addresses to Perforce user account email addresses during the authorization check.

        :param email_case_sensitivity: The email_case_sensitivity of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._email_case_sensitivity = email_case_sensitivity

    @property
    def author_source(self):
        """
        Gets the author_source of this GitFusionRepoGlobalOverrides.
        Defines the source that Git Fusion uses to identify the Perforce user associated with a Git push.\n\nDefaults to `git-email`.\n\nUse any one of the following values:\n\n- `git-email`: Use the email address of the Git author to look for a Perforce user account with the same email address. Git Fusion consults the p4gf_usermap file first, and if that fails to produce a match, it scans the Perforce user table.\n- `git-user`: Use the user.name field in the Git commit. This is the part of the author field before the email address.\n- `git-email-account`: Use the account portion of the Git author's email address. If the Git author's email value is `samwise@the_shire.com`, Git Fusion uses the Perforce account samwise.\n\nYou can also tell Git Fusion to iterate through multiple source types until it finds a matching Perforce account. Specify the source types in order of precedence, separated by commas. For example: git-user, git-email-account, git-email.

        :return: The author_source of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._author_source

    @author_source.setter
    def author_source(self, author_source):
        """
        Sets the author_source of this GitFusionRepoGlobalOverrides.
        Defines the source that Git Fusion uses to identify the Perforce user associated with a Git push.\n\nDefaults to `git-email`.\n\nUse any one of the following values:\n\n- `git-email`: Use the email address of the Git author to look for a Perforce user account with the same email address. Git Fusion consults the p4gf_usermap file first, and if that fails to produce a match, it scans the Perforce user table.\n- `git-user`: Use the user.name field in the Git commit. This is the part of the author field before the email address.\n- `git-email-account`: Use the account portion of the Git author's email address. If the Git author's email value is `samwise@the_shire.com`, Git Fusion uses the Perforce account samwise.\n\nYou can also tell Git Fusion to iterate through multiple source types until it finds a matching Perforce account. Specify the source types in order of precedence, separated by commas. For example: git-user, git-email-account, git-email.

        :param author_source: The author_source of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._author_source = author_source

    @property
    def limit_space_mb(self):
        """
        Gets the limit_space_mb of this GitFusionRepoGlobalOverrides.
        Natural number representing the number of megabytes of disk space that can be consumed by any single repo.\nThis value does not include the spaced consumed on the Perforce server.

        :return: The limit_space_mb of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._limit_space_mb

    @limit_space_mb.setter
    def limit_space_mb(self, limit_space_mb):
        """
        Sets the limit_space_mb of this GitFusionRepoGlobalOverrides.
        Natural number representing the number of megabytes of disk space that can be consumed by any single repo.\nThis value does not include the spaced consumed on the Perforce server.

        :param limit_space_mb: The limit_space_mb of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._limit_space_mb = limit_space_mb

    @property
    def limit_commits_received(self):
        """
        Gets the limit_commits_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of commits allowed in a single push.

        :return: The limit_commits_received of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._limit_commits_received

    @limit_commits_received.setter
    def limit_commits_received(self, limit_commits_received):
        """
        Sets the limit_commits_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of commits allowed in a single push.

        :param limit_commits_received: The limit_commits_received of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._limit_commits_received = limit_commits_received

    @property
    def limit_files_received(self):
        """
        Gets the limit_files_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of files allowed in a single push.

        :return: The limit_files_received of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._limit_files_received

    @limit_files_received.setter
    def limit_files_received(self, limit_files_received):
        """
        Sets the limit_files_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of files allowed in a single push.

        :param limit_files_received: The limit_files_received of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._limit_files_received = limit_files_received

    @property
    def limit_megabytes_received(self):
        """
        Gets the limit_megabytes_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of megabytes allowed in a single push.

        :return: The limit_megabytes_received of this GitFusionRepoGlobalOverrides.
        :rtype: str
        """
        return self._limit_megabytes_received

    @limit_megabytes_received.setter
    def limit_megabytes_received(self, limit_megabytes_received):
        """
        Sets the limit_megabytes_received of this GitFusionRepoGlobalOverrides.
        Natural number representing the maximum number of megabytes allowed in a single push.

        :param limit_megabytes_received: The limit_megabytes_received of this GitFusionRepoGlobalOverrides.
        :type: str
        """
        self._limit_megabytes_received = limit_megabytes_received

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

