# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Location(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Location - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'depot_path': 'str',
            'depot': 'DepotsCommand',
            'dir': 'DirsCommand',
            'file': 'FilesCommand',
            'fstat': 'FstatCommand',
            'content': 'str'
        }

        self.attribute_map = {
            'depot_path': 'depotPath',
            'depot': 'depot',
            'dir': 'dir',
            'file': 'file',
            'fstat': 'fstat',
            'content': 'content'
        }

        self._depot_path = None
        self._depot = None
        self._dir = None
        self._file = None
        self._fstat = None
        self._content = None

    @property
    def depot_path(self):
        """
        Gets the depot_path of this Location.
        An absolute depot path specification.

        :return: The depot_path of this Location.
        :rtype: str
        """
        return self._depot_path

    @depot_path.setter
    def depot_path(self, depot_path):
        """
        Sets the depot_path of this Location.
        An absolute depot path specification.

        :param depot_path: The depot_path of this Location.
        :type: str
        """
        self._depot_path = depot_path

    @property
    def depot(self):
        """
        Gets the depot of this Location.


        :return: The depot of this Location.
        :rtype: DepotsCommand
        """
        return self._depot

    @depot.setter
    def depot(self, depot):
        """
        Sets the depot of this Location.


        :param depot: The depot of this Location.
        :type: DepotsCommand
        """
        self._depot = depot

    @property
    def dir(self):
        """
        Gets the dir of this Location.


        :return: The dir of this Location.
        :rtype: DirsCommand
        """
        return self._dir

    @dir.setter
    def dir(self, dir):
        """
        Sets the dir of this Location.


        :param dir: The dir of this Location.
        :type: DirsCommand
        """
        self._dir = dir

    @property
    def file(self):
        """
        Gets the file of this Location.


        :return: The file of this Location.
        :rtype: FilesCommand
        """
        return self._file

    @file.setter
    def file(self, file):
        """
        Sets the file of this Location.


        :param file: The file of this Location.
        :type: FilesCommand
        """
        self._file = file

    @property
    def fstat(self):
        """
        Gets the fstat of this Location.


        :return: The fstat of this Location.
        :rtype: FstatCommand
        """
        return self._fstat

    @fstat.setter
    def fstat(self, fstat):
        """
        Sets the fstat of this Location.


        :param fstat: The fstat of this Location.
        :type: FstatCommand
        """
        self._fstat = fstat

    @property
    def content(self):
        """
        Gets the content of this Location.
        If this location indicates a single file, this can be set with the Base64-encoded content of the file.

        :return: The content of this Location.
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """
        Sets the content of this Location.
        If this location indicates a single file, this can be set with the Base64-encoded content of the file.

        :param content: The content of this Location.
        :type: str
        """
        self._content = content

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

